﻿{{
┌────────────────────────────────────────────────────────────────────────────┐
│ mandelbrot16_512x384_vga                                   (yeti@20170604) │
├────────────────────────────────────────────────────────────────────────────┤
│ Scroll down for MIT License text.                                          │
└────────────────────────────────────────────────────────────────────────────┘
}}

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  tiles    = vga#xtiles * vga#ytiles
  tiles32  = tiles * 32

  xmin=-8601	' int(-2.1*4096)
  xmax=2867	' int( 0.7*4096)

  ymin=-4915	' int(-1.2*4096)
  ymax=4915	' int( 1.2*4096)

  maxiter=16

OBJ

  vga : "VGA_512x384_Bitmap"


VAR

  long  sync, pixels[tiles32]
  word  colors[tiles]


PUB start | i,c,cx,cy,dx,dy,x,y,xn,yn,rsq,iter,xx,yy

  vga.start(16, @colors, @pixels, @sync)

  repeat i from 0 to tiles - 1
    colors[i] := $FC00

  dx:=(xmax-xmin)/511
  dy:=(ymax-ymin)/383

  cy:=ymin
  yy:=0
  repeat while yy<384
    cx:=xmin
    xx:=0
    repeat while xx<512
      x:=0
      y:=0
      rsq:=0
      iter:=0
      repeat while iter=<maxiter and rsq=<16384
        xn:=((x*x-y*y)~>12)+cx
        yn:=((x*y)~>11)+cy
        x:=xn
        y:=yn
        rsq:=(x*x+y*y)~>12
        iter+=1
      if iter & 1
        pixels[yy << 4 + xx >> 5] |= |< xx  
      cx+=dx
      xx+=1
    cy+=dy
    yy+=1

{{
┌────────────────────────────────────────────────────────────────────────────┐
│                         TERMS OF USE:  MIT License                         │
├────────────────────────────────────────────────────────────────────────────┤
│ Permission is hereby granted, free of charge, to any person obtaining a    │
│ copy of this software and associated documentation files (the "Software"), │
│ to deal in the Software without restriction, including without limitation  │
│ the rights to use, copy, modify, merge, publish, distribute, sublicense,   │
│ and/or sell copies of the Software, and to permit persons to whom the      │
│ Software is furnished to do so, subject to the following conditions:       │
│                                                                            │
│ The above copyright notice and this permission notice shall be included in │
│ all copies or substantial portions of the Software.                        │
│                                                                            │
│ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR │
│ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,   │
│ FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    │
│ THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER │
│ LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING    │
│ FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER        │
│ DEALINGS IN THE SOFTWARE.                                                  │
└────────────────────────────────────────────────────────────────────────────┘
}}
